///*
// * Galatea Dialog Manager:
// * (c)2003-2004 Takuya NISHIMOTO (nishi@hil.t.u-tokyo.ac.jp)
// * Based on Phoenix By Takuya NISHIMOTO and Mitsuhiro KIZU
// *
// * $Id: VXMLDoc2.java,v 1.2 2007/01/15 03:16:37 nishi Exp $
// */
//
//package galatea.document;
//
//import galatea.command.EvaluateCommand;
//import galatea.relaxer.vxml20.IVxmlVxmlChoice;
//import galatea.relaxer.vxml20.URVisitor;
//import galatea.relaxer.vxml20.VxmlLink;
//import galatea.relaxer.vxml20.VxmlVar;
//import galatea.relaxer.vxml20.VxmlVxml;
//import galatea.util.Logger;
//import galatea.util.Property;
//import galatea.util.Util;
//
//import java.util.ArrayList;
//
//import org.w3c.dom.Element;
//
//
//public class VXMLDoc2 implements IAbstractDoc // VoiceXML形式
//{
//	final static String VXML_START_NAME = "@vxml_start";
//	
//	Logger dbg = new Logger("VXMLDoc");
//	String docAddress_ = null;
//	
//	StateMap stateMap_ = null;
//	
//	ArrayList docErrors_ = null;
//	ArrayList docWarnings_ = null;
//	
//	private double promptTimeout_;
//	private int unique_ = 0;
//	
////	String _getEvalWith(String s, String w) {
////		if (s == null) 
////			return "true";
////		if ( w.length() > 0 ) {
////			// "with(" + w + "){" + s + "}"
////			StringBuffer script = new StringBuffer("with(");
////			script.append(w);
////			script.append("){");
////			script.append(s);
////			script.append("}");
////			return script.toString();
////		} 
////		return s;
////	}
//	
//	
//	String _getUniqueId(String str)
//	{
//		unique_++;
//		return "vxml_"+ str + unique_;
//	}
//	
//	/**
//	 * ドキュメント中の相対pathを絶対pathに変換する
//	 */
//	String resolveAdrs(String org)
//	{
//		return Util.resolveAdrs(docAddress_, org);
//	}
//	
//	
//	private void _addAppInitStates(VxmlVxml vxmlVxml, StateMap stateMap, String dialog) 
//	throws Exception
//	{
//		String app = vxmlVxml.getApplication();
//		String appInitScript = 
//			"document={};" +
//			"dialog={};";
//		if (app == null) {
//			appInitScript += 
//				"session={telephone:{ani:\"0\"}};" 
//				+ "application={lastresult$:{}};";
//			
//		} else {
//			
//			appInitScript += 
//				"var $root='" + docAddress_ + "';\n"
//				+ "if ($current_root == undefined) {\n"
//				+ "  var $current_root;\n" 
//				+ "}\n" 
//				+ "if ($current_root != $root) {\n" 
//				+ "  $current_root = $root;\n" 
//				+ "  session = {};\n"
//				+ "  application = {lastresult$:{}};";
//			
//			String applicationRoot = resolveAdrs(app);
//			dbg.print("rootVxml:" + applicationRoot );
//			
//			VxmlVxml rootVxml = new VxmlVxml(applicationRoot);
//			
//			dbg.print("Parsing applicationRoot...",2 );
//			int nContent = rootVxml.sizeContent();
//			for ( int i = 0; i < nContent; i++ ) {
//				IVxmlVxmlChoice choice = rootVxml.getContent(i);
//				
//				if ( choice instanceof VxmlVar ) {
//					VxmlVar var = (VxmlVar)choice;
//					String name = var.getName();
//					String expr = var.getExpr();
//					String command = "  application."+name+"="+expr+";\n";
//					
//					appInitScript += command;
//					
//				} else if ( choice instanceof VxmlLink ) {
//					VxmlLink link = (VxmlLink)choice;
//					String n = link.getNext();
//					// next は appRoot からの相対アドレスなので正規化が必要
//					String next = Util.resolveAdrs(applicationRoot, n);
//					dbg.print("link next="+next );
//				}
//			}
//			appInitScript += "}\n";
//		}
//		
//		ContentState appInitState = new ContentState();
//		String docName = VXML_START_NAME; // "@vxml_start"
//		appInitState.setName(docName);
//		if ( appInitScript.length() > 0 ) {
//			appInitState.addCommand(new EvaluateCommand(appInitScript));
//		}
//		
//		String firstID = dialog;
//		if (firstID == null || firstID.equals("")) {
//			firstID = DocUtil.getFirstDialogID(vxmlVxml);
//			if(firstID == null) {
//				throw new DocError("VXML leaf document " +docAddress_+ " has no menu or form.");
//			}
//		}
//		
//		stateMap.add(appInitState);
//		stateMap.setFirstStateName(docName);
//		stateMap.addSetNextCommand(docName, "@" + firstID);
//		
//		// stateMap.addCommand(docName, new AddOutItemCommand
//		// (new BreakOutItem(startupWait_ * 1000.0, false)));
//		
//		String script = "$prompt_timeout = "+Double.toString(promptTimeout_ * 1000.0); // in msec
//		stateMap.addCommand(docName, new EvaluateCommand(script));
//		
//		stateMap.addCommand(docName, new EvaluateCommand
//				("$restart_document = '"+docAddress_ +"';"));
//	}
//	
//	
//	/**
//	 * @see main() for usage
//	 */
//	public VXMLDoc2(Element e, String adrs, String dialog) throws Exception
//	{
//		promptTimeout_ = Property.getAsDouble("VXMLDoc.PromptTimeout", 10.0);
//		
//		docErrors_ = new ArrayList();
//		docWarnings_ = new ArrayList();
//		
//		if (VxmlVxml.isMatch(e) == false) {
//			throw new DocError("Not a valid <vxml> document: " + adrs + "#" + dialog);
//		}
//		
//		docAddress_ = adrs + "#" + dialog;
//		
//		stateMap_ = new StateMap();
//		
//		VxmlVxml vxmlVxml = new VxmlVxml(e);
//		_addAppInitStates(vxmlVxml, stateMap_, dialog);
//		
//		VXMLDocVisitor visitor = new VXMLDocVisitor(this);
//		URVisitor.traverse(vxmlVxml, visitor);
//		
//		if ( docErrors_.size() > 0 ) {
//			String err = "";
//			for ( int i = 0; i < docErrors_.size(); i++ ) {
//				err += docErrors_.get(i).toString() + "\n";
//			}
//			throw new DocError("Leaf document has following error(s):\n" + err);
//		}
//		
//	}
//	
//	public StateMap getStateMap()
//	{
//		return stateMap_;
//	}
//	
//	public String getDocWarnings() {
//		String w = "";
//		for ( int i = 0, n = docWarnings_.size(); i < n ; i++ ) {
//			w += docWarnings_.get(i) + "\n";
//		}
//		return w;
//	}
//	
//}
